Index: src/Actions/WorldAction/AddEmptyBoundaryAction.cpp
===================================================================
--- src/Actions/WorldAction/AddEmptyBoundaryAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/AddEmptyBoundaryAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,10 +6,16 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/WorldAction/AddEmptyBoundaryAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
-#include "log.hpp"
-#include "vector.hpp"
+#include "Helpers/Log.hpp"
+#include "LinearAlgebra/Vector.hpp"
 #include "World.hpp"
 
@@ -22,5 +28,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 #include "Helpers/Assert.hpp"
 
@@ -34,6 +40,18 @@
 {}
 
+void WorldAddEmptyBoundary(Vector &boundary) {
+  ValueStorage::getInstance().setCurrentValue(WorldAddEmptyBoundaryAction::NAME, boundary);
+  ActionRegistry::getInstance().getActionByName(WorldAddEmptyBoundaryAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* WorldAddEmptyBoundaryAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryVector(NAME, false, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr WorldAddEmptyBoundaryAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   Vector boundary;
   Vector Min;
@@ -41,40 +59,36 @@
   int j=0;
 
-  dialog->queryVector(NAME, &boundary, World::getInstance().getDomain(), false, MapOfActions::getInstance().getDescription(NAME));
+  ValueStorage::getInstance().queryCurrentValue(NAME, boundary);
 
-  if(dialog->display()) {
-    // get maximum and minimum
-    vector<atom *> AllAtoms = World::getInstance().getAllAtoms();
-    ASSERT(AllAtoms.size() > 0, "There must be atoms present for AddingEmptyBoundary.");
-    vector<atom *>::iterator AtomRunner = AllAtoms.begin();
-    Min = (*AtomRunner)->x;
-    Max = (*AtomRunner)->x;
-    for (; AtomRunner != AllAtoms.end(); ++AtomRunner) {
-      for (int i=0;i<NDIM;i++) {
-        if ((*AtomRunner)->x[i] > Max[i])
-          Max[i] = (*AtomRunner)->x[i];
-        if ((*AtomRunner)->x[i] < Min[i])
-          Min[i] = (*AtomRunner)->x[i];
-      }
+  // get maximum and minimum
+  vector<atom *> AllAtoms = World::getInstance().getAllAtoms();
+  ASSERT(AllAtoms.size() > 0, "There must be atoms present for AddingEmptyBoundary.");
+  vector<atom *>::iterator AtomRunner = AllAtoms.begin();
+  Min = (*AtomRunner)->getPosition();
+  Max = (*AtomRunner)->getPosition();
+  for (; AtomRunner != AllAtoms.end(); ++AtomRunner) {
+    for (int i=0;i<NDIM;i++) {
+      if ((*AtomRunner)->at(i) > Max[i])
+        Max[i] = (*AtomRunner)->at(i);
+      if ((*AtomRunner)->at(i) < Min[i])
+        Min[i] = (*AtomRunner)->at(i);
     }
-    // set new box size
-    double * const cell_size = World::getInstance().getDomain();
-    for (j=0;j<6;j++)
-      cell_size[j] = 0.;
-    j=-1;
-    for (int i=0;i<NDIM;i++) {
-      j += i+1;
-      cell_size[j] = (Max[i]-Min[i]+2.*boundary[i]);
-    }
-    // translate all atoms, such that Min is aty (0,0,0)
-    AtomRunner = AllAtoms.begin();
-    for (; AtomRunner != AllAtoms.end(); ++AtomRunner)
-      (*AtomRunner)->x -= Min - boundary;
-    delete dialog;
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
   }
+  // set new box size
+  double * const cell_size = new double[6];
+  for (j=0;j<6;j++)
+    cell_size[j] = 0.;
+  j=-1;
+  for (int i=0;i<NDIM;i++) {
+    j += i+1;
+    cell_size[j] = (Max[i]-Min[i]+2.*boundary[i]);
+  }
+  World::getInstance().setDomain(cell_size);
+  delete[] cell_size;
+  // translate all atoms, such that Min is aty (0,0,0)
+  AtomRunner = AllAtoms.begin();
+  for (; AtomRunner != AllAtoms.end(); ++AtomRunner)
+    *(*AtomRunner) -= Min - boundary;
+  return Action::success;
 }
 
Index: src/Actions/WorldAction/AddEmptyBoundaryAction.hpp
===================================================================
--- src/Actions/WorldAction/AddEmptyBoundaryAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/AddEmptyBoundaryAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,6 +10,11 @@
 
 #include "Actions/Action.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
+void WorldAddEmptyBoundary(Vector &boundary);
 
 class WorldAddEmptyBoundaryAction : public Action {
+  friend void WorldAddEmptyBoundary(Vector &boundary);
+
 public:
   WorldAddEmptyBoundaryAction();
@@ -20,4 +25,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/WorldAction/BoundInBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/BoundInBoxAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/BoundInBoxAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,8 +6,14 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/WorldAction/BoundInBoxAction.hpp"
-#include "log.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 #include "World.hpp"
@@ -21,5 +27,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 
 const char WorldBoundInBoxAction::NAME[] = "bound-in-box";
@@ -32,21 +38,24 @@
 {}
 
+void WorldBoundInBox() {
+  ActionRegistry::getInstance().getActionByName(WorldBoundInBoxAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* WorldBoundInBoxAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr WorldBoundInBoxAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
 
-  dialog->queryEmpty(NAME, MapOfActions::getInstance().getDescription(NAME));
-
-  if(dialog->display()) {
-    // center
-    vector<molecule*> AllMolecules = World::getInstance().getAllMolecules();
-    for (vector<molecule*>::iterator MolRunner = AllMolecules.begin(); MolRunner != AllMolecules.end(); ++MolRunner) {
-      (*MolRunner)->BoundInBox();
-    }
-    delete dialog;
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
+  // center
+  vector<molecule*> AllMolecules = World::getInstance().getAllMolecules();
+  for (vector<molecule*>::iterator MolRunner = AllMolecules.begin(); MolRunner != AllMolecules.end(); ++MolRunner) {
+    (*MolRunner)->BoundInBox();
   }
+  return Action::success;
 }
 
Index: src/Actions/WorldAction/BoundInBoxAction.hpp
===================================================================
--- src/Actions/WorldAction/BoundInBoxAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/BoundInBoxAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,9 @@
 #include "Actions/Action.hpp"
 
+void WorldBoundInBox();
+
 class WorldBoundInBoxAction : public Action {
+  friend void WorldBoundInBox();
+
 public:
   WorldBoundInBoxAction();
@@ -20,4 +24,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/WorldAction/CenterInBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/CenterInBoxAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/CenterInBoxAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,8 +6,15 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/WorldAction/CenterInBoxAction.hpp"
-#include "log.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Box.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 #include "World.hpp"
@@ -20,5 +27,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 
 const char WorldCenterInBoxAction::NAME[] = "center-in-box";
@@ -31,23 +38,29 @@
 {}
 
+void WorldCenterInBox(Box &_box) {
+  ValueStorage::getInstance().setCurrentValue(WorldCenterInBoxAction::NAME, _box);
+  ActionRegistry::getInstance().getActionByName(WorldCenterInBoxAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* WorldCenterInBoxAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryBox(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr WorldCenterInBoxAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
 
-  double * cell_size = World::getInstance().getDomain();
-  dialog->queryBox(NAME, &cell_size, MapOfActions::getInstance().getDescription(NAME));
+  Box& cell_size = World::getInstance().getDomain();
+  ValueStorage::getInstance().queryCurrentValue(NAME, cell_size);
+  World::getInstance().setDomain(cell_size.getM());
 
-  if(dialog->display()) {
-    World::getInstance().setDomain(cell_size);
-    // center
-    vector<molecule *> AllMolecules = World::getInstance().getAllMolecules();
-    for (vector<molecule*>::iterator MolRunner = AllMolecules.begin(); MolRunner != AllMolecules.end(); ++MolRunner) {
-      (*MolRunner)->CenterInBox();
-    }
-    delete dialog;
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
+  // center
+  vector<molecule *> AllMolecules = World::getInstance().getAllMolecules();
+  for (vector<molecule*>::iterator MolRunner = AllMolecules.begin(); MolRunner != AllMolecules.end(); ++MolRunner) {
+    (*MolRunner)->CenterInBox();
   }
+  return Action::success;
 }
 
Index: src/Actions/WorldAction/CenterInBoxAction.hpp
===================================================================
--- src/Actions/WorldAction/CenterInBoxAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/CenterInBoxAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,6 +10,11 @@
 
 #include "Actions/Action.hpp"
+#include "Box.hpp"
+
+void WorldCenterInBox(Box &_box);
 
 class WorldCenterInBoxAction : public Action {
+  friend void WorldCenterInBox(Box &_box);
+
 public:
   WorldCenterInBoxAction();
@@ -20,4 +25,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/WorldAction/CenterOnEdgeAction.cpp
===================================================================
--- src/Actions/WorldAction/CenterOnEdgeAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/CenterOnEdgeAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,11 +6,18 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/WorldAction/CenterOnEdgeAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
-#include "log.hpp"
-#include "vector.hpp"
+#include "Helpers/Log.hpp"
+#include "LinearAlgebra/Vector.hpp"
 #include "World.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 
 #include <iostream>
@@ -21,5 +28,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 #include "Helpers/Assert.hpp"
 
@@ -33,46 +40,47 @@
 {}
 
+void WorldCenterOnEdge() {
+  ActionRegistry::getInstance().getActionByName(WorldCenterOnEdgeAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* WorldCenterOnEdgeAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr WorldCenterOnEdgeAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   Vector Min;
   Vector Max;
-  int j=0;
 
-  dialog->queryEmpty(NAME, MapOfActions::getInstance().getDescription(NAME));
+  // get maximum and minimum
+  vector<atom *> AllAtoms = World::getInstance().getAllAtoms();
+  ASSERT(AllAtoms.size() > 0, "For CenteronEdge atoms must be present.");
+  vector<atom *>::iterator AtomRunner = AllAtoms.begin();
+  Min = (*AtomRunner)->getPosition();
+  Max = (*AtomRunner)->getPosition();
+  for (; AtomRunner != AllAtoms.end(); ++AtomRunner) {
+    for (int i=0;i<NDIM;i++) {
+      if ((*AtomRunner)->at(i) > Max[i])
+        Max[i] = (*AtomRunner)->at(i);
+      if ((*AtomRunner)->at(i) < Min[i])
+        Min[i] = (*AtomRunner)->at(i);
+    }
+  }
+  // set new box size
+  Matrix domain;
+  for (int i=0;i<NDIM;i++) {
+    double tmp = Max[i]-Min[i];
+    tmp = fabs(tmp)>=1. ? tmp : 1.0;
+    domain.at(i,i) = tmp;
+  }
+  World::getInstance().setDomain(domain);
+  // translate all atoms, such that Min is aty (0,0,0)
+  for (vector<atom*>::iterator AtomRunner = AllAtoms.begin(); AtomRunner != AllAtoms.end(); ++AtomRunner)
+    *(*AtomRunner) -= Min;
 
-  if(dialog->display()) {
-    // get maximum and minimum
-    vector<atom *> AllAtoms = World::getInstance().getAllAtoms();
-    ASSERT(AllAtoms.size() > 0, "For CenteronEdge atoms must be present.");
-    vector<atom *>::iterator AtomRunner = AllAtoms.begin();
-    Min = (*AtomRunner)->x;
-    Max = (*AtomRunner)->x;
-    for (; AtomRunner != AllAtoms.end(); ++AtomRunner) {
-      for (int i=0;i<NDIM;i++) {
-        if ((*AtomRunner)->x[i] > Max[i])
-          Max[i] = (*AtomRunner)->x[i];
-        if ((*AtomRunner)->x[i] < Min[i])
-          Min[i] = (*AtomRunner)->x[i];
-      }
-    }
-    // set new box size
-    double * const cell_size = World::getInstance().getDomain();
-    for (j=0;j<6;j++)
-      cell_size[j] = 0.;
-    j=-1;
-    for (int i=0;i<NDIM;i++) {
-      j += i+1;
-      cell_size[j] = (Max[i]-Min[i]);
-    }
-    World::getInstance().setDomain(cell_size);
-    // translate all atoms, such that Min is aty (0,0,0)
-    for (vector<atom*>::iterator AtomRunner = AllAtoms.begin(); AtomRunner != AllAtoms.end(); ++AtomRunner)
-      (*AtomRunner)->x -= Min;
-    delete dialog;
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
-  }
+  return Action::success;
 }
 
Index: src/Actions/WorldAction/CenterOnEdgeAction.hpp
===================================================================
--- src/Actions/WorldAction/CenterOnEdgeAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/CenterOnEdgeAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,9 @@
 #include "Actions/Action.hpp"
 
+void WorldCenterOnEdge();
+
 class WorldCenterOnEdgeAction : public Action {
+  friend void WorldCenterOnEdge();
+
 public:
   WorldCenterOnEdgeAction();
@@ -20,4 +24,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/WorldAction/ChangeBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/ChangeBoxAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/ChangeBoxAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,10 +6,18 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/WorldAction/ChangeBoxAction.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
+#include "Box.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 
 #include <iostream>
@@ -20,5 +28,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 
 const char WorldChangeBoxAction::NAME[] = "change-box";
@@ -31,19 +39,25 @@
 {}
 
+void WorldChangeBox(Box &_box) {
+  ValueStorage::getInstance().setCurrentValue(WorldChangeBoxAction::NAME, _box);
+  ActionRegistry::getInstance().getActionByName(WorldChangeBoxAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* WorldChangeBoxAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryBox(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr WorldChangeBoxAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
 
-  double * cell_size = World::getInstance().getDomain();
-  dialog->queryBox(NAME, &cell_size, MapOfActions::getInstance().getDescription(NAME));
+  Box cell_size;
+  ValueStorage::getInstance().queryCurrentValue(NAME, cell_size);
+  World::getInstance().setDomain(cell_size.getM()); // this is needed as only this function is OBSERVEd.
 
-  if(dialog->display()) {
-    DoLog(0) && (Log() << Verbose(0) << "Setting box domain to " << cell_size[0] << "," << cell_size[1] << "," << cell_size[2] << "," << cell_size[3] << "," << cell_size[4] << "," << cell_size[5] << "," << endl);
-    World::getInstance().setDomain(cell_size);
-    delete dialog;
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
-  }
+  DoLog(0) && (Log() << Verbose(0) << "Setting box domain to " << World::getInstance().getDomain().getM() << endl);
+  return Action::success;
 }
 
Index: src/Actions/WorldAction/ChangeBoxAction.hpp
===================================================================
--- src/Actions/WorldAction/ChangeBoxAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/ChangeBoxAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,6 +10,11 @@
 
 #include "Actions/Action.hpp"
+#include "Box.hpp"
+
+void WorldChangeBox(Box &_box);
 
 class WorldChangeBoxAction : public Action {
+  friend void WorldChangeBox(Box &_box);
+
 public:
   WorldChangeBoxAction();
@@ -20,4 +25,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/WorldAction/InputAction.cpp
===================================================================
--- src/Actions/WorldAction/InputAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/InputAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,12 +6,18 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/WorldAction/InputAction.hpp"
-#include "log.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 #include "Parser/FormatParserStorage.hpp"
 #include "Parser/PcpParser.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -23,5 +29,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 
 const char WorldInputAction::NAME[] = "input";
@@ -34,6 +40,18 @@
 {}
 
+void WorldInput(std::string &filename) {
+  ValueStorage::getInstance().setCurrentValue(WorldInputAction::NAME, filename);
+  ActionRegistry::getInstance().getActionByName(WorldInputAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* WorldInputAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr WorldInputAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   MoleculeListClass *molecules = World::getInstance().getMolecules();
   molecule *mol = NULL;
@@ -41,44 +59,38 @@
   std::ifstream test;
 
-  dialog->queryString(NAME, &filename, MapOfActions::getInstance().getDescription(NAME));
+  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
 
-  if(dialog->display()) {
-    DoLog(0) && (Log() << Verbose(0) << "Config file given." << endl);
-    if (filename.find('.') != string::npos) {
-      std::string FilenamePrefix = filename.substr(0,filename.find_last_of('.'));
-      std::string FilenameSuffix = filename.substr(filename.find_last_of('.')+1, filename.length());
-      DoLog(1) && (Log() << Verbose(1) << "Setting config file name prefix to " << FilenamePrefix << "." << endl);
-      test.open(filename.c_str());
-      if (test == NULL) {
-        DoLog(1) && (Log() << Verbose(1) << "Specified config file " << filename << " not found." << endl);
-      } else {
-        DoLog(1) && (Log() << Verbose(1) << "Specified config file found, parsing ... ");
-        FormatParserStorage::getInstance().get((std::istream &)test, FilenameSuffix);
-        test.close();
-      }
-      FormatParserStorage::getInstance().SetOutputPrefixForAll(FilenamePrefix);
-      // set mol to first active molecule
-      if (molecules->ListOfMolecules.size() != 0) {
-        for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++)
-          if ((*ListRunner)->ActiveFlag) {
-            mol = *ListRunner;
-            break;
-          }
-      }
-      if (mol == NULL) {
-        mol = World::getInstance().createMolecule();
-        mol->ActiveFlag = true;
-        molecules->insert(mol);
-      }
-      mol->SetNameFromFilename(filename.substr(0,filename.find('.')).c_str());
+  DoLog(0) && (Log() << Verbose(0) << "Config file given." << endl);
+  if (filename.find('.') != string::npos) {
+    std::string FilenamePrefix = filename.substr(0,filename.find_last_of('.'));
+    std::string FilenameSuffix = filename.substr(filename.find_last_of('.')+1, filename.length());
+    DoLog(1) && (Log() << Verbose(1) << "Setting config file name prefix to " << FilenamePrefix << "." << endl);
+    test.open(filename.c_str());
+    if (test == NULL) {
+      DoLog(1) && (Log() << Verbose(1) << "Specified config file " << filename << " not found." << endl);
     } else {
-      DoeLog(1) && (eLog() << Verbose(1) << "Input file does not have a suffix, cannot recognize format." << endl);
+      DoLog(1) && (Log() << Verbose(1) << "Specified config file found, parsing ... ");
+      FormatParserStorage::getInstance().get((std::istream &)test, FilenameSuffix);
+      test.close();
     }
-    delete dialog;
-    return Action::success;
+    FormatParserStorage::getInstance().SetOutputPrefixForAll(FilenamePrefix);
+    // set mol to first active molecule
+    if (molecules->ListOfMolecules.size() != 0) {
+      for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++)
+        if ((*ListRunner)->ActiveFlag) {
+          mol = *ListRunner;
+          break;
+        }
+    }
+    if (mol == NULL) {
+      mol = World::getInstance().createMolecule();
+      mol->ActiveFlag = true;
+      molecules->insert(mol);
+    }
+    mol->SetNameFromFilename(filename.substr(0,filename.find('.')).c_str());
   } else {
-    delete dialog;
-    return Action::failure;
+    DoeLog(1) && (eLog() << Verbose(1) << "Input file does not have a suffix, cannot recognize format." << endl);
   }
+  return Action::success;
 }
 
Index: src/Actions/WorldAction/InputAction.hpp
===================================================================
--- src/Actions/WorldAction/InputAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/InputAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,9 @@
 #include "Actions/Action.hpp"
 
+void WorldInput(std::string &filename);
+
 class WorldInputAction : public Action {
+  friend void WorldInput(std::string &filename);
+
 public:
   WorldInputAction();
@@ -20,4 +24,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/WorldAction/OutputAction.cpp
===================================================================
--- src/Actions/WorldAction/OutputAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/OutputAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,10 +6,16 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/WorldAction/OutputAction.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "Parser/ChangeTracker.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -21,5 +27,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 
 const char WorldOutputAction::NAME[] = "output";
@@ -32,18 +38,21 @@
 {}
 
+void WorldOutput() {
+  ActionRegistry::getInstance().getActionByName(WorldOutputAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* WorldOutputAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr WorldOutputAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
 
-  dialog->queryEmpty(NAME, MapOfActions::getInstance().getDescription(NAME));
-
-  if(dialog->display()) {
-    DoLog(0) && (Log() << Verbose(0) << "Saving world to files." << endl);
-    ChangeTracker::getInstance().saveStatus();
-    delete dialog;
-    return Action::success;
-  } else {
-    delete dialog;
-    return Action::failure;
-  }
+  DoLog(0) && (Log() << Verbose(0) << "Saving world to files." << endl);
+  ChangeTracker::getInstance().saveStatus();
+  return Action::success;
 }
 
Index: src/Actions/WorldAction/OutputAction.hpp
===================================================================
--- src/Actions/WorldAction/OutputAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/WorldAction/OutputAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,9 @@
 #include "Actions/Action.hpp"
 
+void WorldOutput();
+
 class WorldOutputAction : public Action {
+  friend void WorldOutput();
+
 public:
   WorldOutputAction();
@@ -20,4 +24,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
